use serde::{Deserialize, Serialize};

// This is what Wolves returns to us
#[derive(Deserialize, Serialize, Debug)]
struct WolvesResult {
    success: i8,
    result: Vec<WolvesResultCNS>,
}

// this is teh actual data we care about
#[derive(Deserialize, Serialize, Debug)]
struct WolvesResultCNS {
    id: String,
    name: String,
    // Link to their page such as https://ulwolves.ie/society/computer
    link: String,
    // array of Committee members member_id's
    committee: Vec<String>,
}

        async fn get_committees(config: &Config) -> Vec<WolvesResultCNS> {
    if config.wolves_url.is_empty() {
        return vec![];
    }

    // TODO: Change teh stored env value to teh base domain
    // TODO: this address may change
    let url = format!("{}/get_cns", &config.wolves_url);

    // get wolves data
    if let Ok(mut res) = surf::post(&url).header("X-AM-Identity", &config.wolves_api).await {
        if let Ok(WolvesResult {
                      success,
                      result,
                  }) = res.body_json().await
        {
            if success != 1 {
                return vec![];
            }

            return result;
        }
    }

    vec![]
}