use serde::{Deserialize, Serialize};


#[derive(Deserialize, Serialize, Debug)]
struct WolvesResult {
    success: i8,
    result: Vec<WolvesResultUser>,
}

#[derive(Deserialize, Serialize, Debug)]
struct WolvesResultUser {
    // TODO: Might be worth trying to get this replaced with the club/soc ID?
    committee: String,
    member_id: String,
    first_name: String,
    last_name: String,
    contact_email: String,
    opt_in_email: String,
    student_id: Option<String>,
    note: Option<String>,
    expiry: String,
    requested: String,
    approved: String,
    sitename: String,
    domain: String,
}

async fn get_wolves_sub(wolves_url_base: &str, wolves_api: &str) -> Vec<WolvesResultUser> {
    if wolves_url_base.is_empty() {
        return vec![];
    }

    let url = format!("{}/get_members", wolves_url_base);

    // get wolves data
    if let Ok(mut res) = surf::post(&url).header("X-AM-Identity", wolves_api).await {
        if let Ok(WolvesResult {
                      success,
                      result,
                  }) = res.body_json().await
        {
            if success != 1 {
                return vec![];
            }

            return result;
        }
    }

    vec![]
}